#include <stdio.h>
#include <time.h>
#include <string.h>
#include <arpa/inet.h>

#include "TCPclient.h"


#define TIMEOUT 1*CLOCKS_PER_SEC
#define TCP_PORT 23365

int main(int argc, char* argv[])
{
 char buffer[1024] = "ASK\r\n"; // stringa di richiesta
 unsigned long start, now;
 int i, n;
 TCPclient* socket;

 if (argc<2)
	 {
		printf("Deve essere fornito l'indirizzo IP del server!\r\n");
		return -1;
	 }
 // connessione al server (numero di porta 23365)
 socket = new TCPclient(argv[1], TCP_PORT);
 
 if (socket == nullptr)
	 {
		printf("Errore creazione socket!\r\n");
		return -1;
	 }
 if (!socket->isConnected())
	 {
		printf("Errore connessione server!\r\n");
		return -1;
	 }
	 
 // trasmissione richiesta al server
 socket->sendData(buffer, strlen(buffer));
 i = 0;
 start = clock(); // tempo iniziale attesa
 now = clock(); // tempo attuale
 // ciclo di attesa risposta per al massimo un tempo pari a TIMEOUT
 while ((now - start) < TIMEOUT)
			{
			 if ((n = socket->receiveData(&buffer[i], sizeof(buffer)-i)) > 0)
				 {
					// ricevuti caratteri: ricostruzione risposta
					i += n;
					if (buffer[i-1] == '\r' || buffer[i-1] == '\n')
						{
						 // risposta completa
                         buffer[i-2] = '\0';
						 printf("Ricevuto numero %s.\r\n", buffer);
						 delete socket;
						 return 0;
						}
					}
				now = clock(); // aggiornamento tempo attuale
			 }
 // trascorso un tempo pari a TIMEOUT senza completamento risposta
 printf("Nessuna risposta ricevuta!\r\n");
 delete socket;
 return -1;
}
