#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>

int main(void)
{
 int request_socket_id; // socket per richieste di connessione
 int communication_socket_id; // socket di comunicazione con client
 struct sockaddr_in server_add; // struttura per indirizzo server
 struct sockaddr_in client_add; // struttura per indirizzo client
 size_t client_add_size;
 time_t timestamp;
 struct tm *now;
 char *datetime;
 
 // apertura del socket
 if ((request_socket_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
   {
    printf("Errore apertura socket!\r\n");
    return -1;
   }
 // costruzione della struttura per l’indirizzo del server
 memset(&server_add, 0, sizeof(server_add));
 server_add.sin_family = AF_INET;
 server_add.sin_addr.s_addr = 0; // indirizzo IP locale
 server_add.sin_port = htons(12345); // numero di porta server
 // associazione del numero di porta al socket
 if (bind(request_socket_id,
          (struct sockaddr *)&server_add, sizeof(server_add)) < 0)
   {
    printf("Errore associazione socket!\r\n");
    close(request_socket_id);
    return -1;
   }
 // impostazione del socket per ricevere le richieste di connessione
 if (listen(request_socket_id, 1) < 0)
   {
    printf("Errore impostazione socket!\r\n");
    close(request_socket_id);
    return -1;
   }
 // ciclo di accettazione delle richieste di connessione da parte dei client
 while (1)
      {
       client_add_size = sizeof(struct sockaddr);
       // attesa richiesta di connessione da parte del client
       communication_socket_id = accept(request_socket_id,
                                        (struct sockaddr*)&client_add,
                                        (socklen_t*)&client_add_size);
       if (communication_socket_id >= 0)
         {
          printf("Effettuata connessione con client.\r\n");
          // acquisizione numero di secondi trascorsi dalle 00:00:00 del 1/1/1970
          time(&timestamp); 
          // trasformazione del timestamp nella data/ora attuale
          now = localtime(&timestamp);
          // trasformazione della struttura in una stringa di caratteri
          datetime = asctime(now);
          // invio al client della stringa
          send(communication_socket_id, datetime, strlen(datetime), 0);
          // invio al client dei caratteri CR e LF
          send(communication_socket_id, "\r\n", 2, 0);
          // chiusura del socket di comunicazione con il client
          close(communication_socket_id);
         }
      }
 close(request_socket_id);
 return 0;
}
