#include <stdio.h>
#include <string.h>
#include <time.h>

#include "_UDP.h"

#define UDP_PORT 23365

int main(void)
{
 unsigned char buffer[1024]; // buffer per ricezione
 unsigned long ip_address;
 unsigned short port_number;
 unsigned long timestamp; // variabile per timestamp
 int n;

 // inizializzazione socket con porta UDP numero 23365
 if (UDP_init(UDP_PORT) < 0)
   {
    printf("Errore inizializzazione socket!\r\n");
    return -1;
   }
 printf("Servizio attivo...\r\n");
 while (1)
 {
  if ((n = UDP_receive( &ip_address, &port_number, buffer, sizeof(buffer))) > 0)
   {
    // ricezione di un datagram 
    buffer[n] = '\0'; // terminatore di stringa
    if (strcmp((char*)buffer, "ASK") == 0)
      {
       // generazione timestamp
       timestamp = time(NULL);
       UDP_send (ip_address, port_number, (void*)&timestamp, sizeof(unsigned long));
       printf("...inviato timestamp %lu.\r\n", timestamp);
      }
   }
 }
 UDP_close();
 return 0;
}
