
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "UDP.h"

#define TIMEOUT 1*CLOCKS_PER_SEC // 1 secondi

struct COMMAND
{
 unsigned char cmd;
 unsigned short tm;
}

struct ANSWER
{
 unsigned char ans;
};


int main(int argc, char* argv[])
{
 unsigned long ip_address;
 unsigned short udp_port;
 unsigned long start, now;
 struct COMMAND command;
 struct ANSWER answer;

 if (argc < 3)
   {
    printf("Deve essere fornito l'indirzzo IP del dispositivo e il tempo di ritardo del comando!\r\n");
    return -1;
   }
 
 if (UDP_init(0) < 0)
   { 
    printf("Errore inizializzazione socket!\r\n");
    return -1;
   }
 
 ip_address = IP_to_bin(argv[1]);
 udp_port = 23365;
#ifdef ON 
 command.cmd = 1;
#endif
#ifdef OFF
 command.cmd = 0;
#endif
 
 command.tm = (unsigned short)atoi(argv[2]);
 
 UDP_send(ip_address, udp_port, (unsigned char*)(&command), sizeof(struct COMMAND));
 
 start = clock();
 now = clock();
 while ((now - start) < TIMEOUT)
      {
       if ((UDP_receive(&ip_address, &udp_port, (unsigned char*)(&answer), sizeof(struct ANSWER))) == sizeof(struct ANSWER))
         {
		  if (answer.ans == 0)
            printf("Ricevuta conferma di esecuzione del comando.\r\n");
          else
		      printf("Ricevuto errore da parte del dispositivo.\r\n");
         }
       now = clock();
      }
 UDP_close();
 return 0;
}
