
#include <stdio.h>
#include <stdlib.h>

#include "UDP.H"


struct COMMAND
{
 unsigned char cmd;
 unsigned short tm;
}

struct ANSWER
{
 unsigned char ans;
};


int main(int argc, char* argv[])
{
 unsigned long ip_address;
 unsigned short udp_port;
 struct ANSWER answer;
 struct COMMAND command;
 FILE* file;
 int n;
 unsigned int timestamp;

 if (argc < 2)
   {
    printf("Deve essere fornito il nome del file!\r\n");
    return -1;
   }
   
 if (UDP_init(23365) < 0)
   { 
    printf("Errore inizializzazione socket!\r\n");
    return -1;
   }
 
 file = fopen(argv[1], "wt");
 if (file == NULL)
   {
    UDP_close();
	printf("Errore apertura file!\r\n");
	return -1;
   }
 
 while (1)
      {
       if ((n = UDP_receive(&ip_address, &udp_port,
	                        (unsigned char*)(&command), sizeof(struct COMMAND))) > 0)
         {
		  if (n != sizeof(struct COMMAND))
		    {
			 printf("Ricevuto comando di lunghezza errata.\r\n");
			 answer.ans = 255;
			 UDP_send(ip_address, udp_port, (unsigned char*)(&answer), sizeof(struct ANSWER));
			 continue;
			}
		  if (command.cmd == 0 || command.cmd == 1)
            {		  
			 if (command.cmd == 0)
			   printf("Ricevuto comando OFF con tempo %u\r\n", command.tm);
			 else
			     printf("Ricevuto comando ON con tempo %u\r\n", command.tm);
             answer.ans = 0;
             UDP_send(ip_address, udp_port, (unsigned char*)(&answer), sizeof(struct ANSWER));
			 timestamp = time(NULL);
			 fprintf(file, "%u, %u, %u, %u\r\n", timestamp, command.cmd, command.tm, ip_address);
			 fflush(file);
			}
		  else
		      {
			   printf("Ricevuto comando sconosciuto.\r\n");
			   answer.ans = 255;
			   UDP_send(ip_address, udp_port, (unsigned char*)(&answer), sizeof(struct ANSWER));
			   continue;
			  }
         }
      }
 UDP_close();
 return 0;
}

