
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "UDP.h"

#define TIMEOUT 10*CLOCKS_PER_SEC // 10 secondi

struct ANSWER
{
 unsigned long matricola;
 unsigned long lettura;
};


int main(int argc, char* argv[])
{
 unsigned long codice;
 unsigned long ip_address;
 unsigned short udp_port;
 unsigned long start, now;
 FILE* file;
 struct ANSWER answer;

 if (argc < 2)
   {
    printf("Deve essere fornito il codice di area!\r\n");
    return -1;
   }
 if ((file = fopen("letture.csv", "w")) == NULL)
   {
    printf("Errore apertura file in scrittura!\r\n");
    return -1;
   }
 if (UDP_init(0) < 0)
   { 
    printf("Errore inizializzazione socket!\r\n");
    return -1;
   }
 
 codice = (unsigned long)atoi(argv[1]);
 ip_address = IP_to_bin("172.16.255.255"); // network broadcast
 udp_port = 23365;
 
 UDP_send(ip_address, udp_port, (unsigned char*)(&codice), sizeof(unsigned long));
 start = clock();
 now = clock();
 
 while ((now - start) < TIMEOUT)
      {
       if ((UDP_receive(&ip_address, &udp_port, (unsigned char*)(&answer), sizeof(struct ANSWER))) == sizeof(struct ANSWER))
         {
          printf("Ricevuta lettura da contatore %lu\r\n", answer.matricola);
          fprintf(file, "%lu, %lu\r\n", answer.matricola, answer.lettura);
		  //fflush(file);
         }
       now = clock();
      }
 fclose(file);
 UDP_close();
 return 0;
}

