
#include <cstring>
#include <cstdio>
#include <cstdlib>

#include "Products.h"


Products::Products(const char filename[])
{
    FILE* file;
    int index, n;
    char line[1024];
    char* token;
    float price;

    // apertura file dei prodotti in formato CSV
    file = fopen(filename, "r");
    if (file == NULL)
    {
    product_number = 0;
    return;
    }
    // ciclo di conteggio delle linee del file
    n = 0;
    do {
        fgets(line, sizeof(line)-1, file);
        n++;
    }
    while (!feof(file));
    if (n == 0)
    {
    product_number = 0;
    fclose(file);
    return;
    }
    // allocazione memoria per vettore prodotti
    products = new PRODUCT[n];
    if (products == nullptr)
    {
    product_number = 0;
    fclose(file);
    return;
    }
    // riposizionamento all’inizio del file dei prodotti
    rewind(file);
    index = 0;
    // ciclo di lettura delle informazioni dei prodotti dal file
    do {
        // lettura di una line dal file
        fgets(line, sizeof(line)-1, file);
        // estrazione delle informazioni del prodotto (separate da ",") e copia nella posizione corrente del vettore
        token = strtok(line, ",\r\n\0");
        if (token != NULL)
        {
        strncpy(products[index].code, token, 15);
        token = strtok(NULL, ",\r\n\0");
        if (token != NULL)
            {
            strncpy(products[index].description, token, 31);
            token = strtok(NULL, ",\r\n\0");
            if (token != NULL)
                {
                price = atof(token);
                if (price != 0)
                {
                    products[index].price = price;
                    index++;
                }
                }
            }
        }
    }
    while (!feof(file));
    fclose(file);
    product_number = index;
}
    
Products::~Products(void)
{
    delete[] products;
}

int Products::getProductNumber(void)
{
    return product_number;
}

bool Products::findProduct(char code[], PRODUCT* product)
{
    int index;

    // ciclo di ricerca sequenziale del codice di prodotto nel vettore
    for (index=0; index<product_number; index++)
    if (strcmp(code, products[index].code) == 0)
        {
        *product = products[index];
        return true;
        }
    return false;
}

