
#include <cstring>
#include <cstdio>

#include "Phonebook.h"


Phonebook::Phonebook(unsigned int size)
{
     phonebook = new ENTRY[size];
     this->size = size;
     N_entry = 0;
}
 
Phonebook::~Phonebook(void)
{
     delete[] phonebook;
}

bool Phonebook::find(char in[], char *out)
{
  int i, n;
 
  n = N_entry;
 
  for (i=0; i<n; i++)
     {
	  semaphore.lock();
	  if (strcmp(in, phonebook[i].name) == 0)
        {
		 strncpy(out, phonebook[i].phone, 15);
		 semaphore.unlock();
		 return true;
        }
	  if (strcmp(in, phonebook[i].phone) == 0)
	    {
		 strncpy(out, phonebook[i].name, 31);
		 semaphore.unlock();
		 return true;
        }
	 semaphore.unlock();
	 }
   return false;
}

bool Phonebook::update(char name[], char phone[])
{
  int i, n;

  n = N_entry;
  for (i=0; i<n; i++)
 	 {
	  semaphore.lock();
	  if (strcmp(name, phonebook[i].name) == 0)
	    {
		 strncpy(phonebook[i].phone, phone, 15);
		 semaphore.unlock();
		 return true;
		 }
	  if (strcmp(phone, phonebook[i].phone) == 0)
	    {
		 strncpy(phonebook[i].name, name, 31);
		 semaphore.unlock();
		 return true;
        }
	  semaphore.unlock();
	 }
  semaphore.lock();
  if (N_entry < size)
    {
     strncpy(phonebook[i].name, name, 31);
     strncpy(phonebook[i].phone, phone, 15);
     N_entry++;
     semaphore.unlock();
     return true;
    }
  else
      {
       semaphore.unlock();
       return false;
      }
}

int Phonebook::loadFromFile(const char filename[])
{
  FILE* file;
  char line[1024];
  char *name, *phone;
  char *p;
 
  file = fopen(filename, "r");
  if (file == NULL)
    return -1;
  semaphore.lock();
  N_entry = 0;
  do {
	  fgets(line, sizeof(line)-1, file);
	  name = strtok_r(line, ",\r\n\0", &p);
	  if (name != NULL)
        {
		 if (strlen(name) > 0)
		   {
		    phone = strtok_r(NULL, ",\r\n\0", &p);
            if (phone != NULL)
			  if (strlen(phone) > 0)
                {
			 	 strncpy(phonebook[N_entry].name, name, 31);
				 strncpy(phonebook[N_entry].phone, phone, 15);
				 N_entry++;
                }
           }
        }
	 } while (!feof(file));
  semaphore.unlock();
  fclose(file);
  return N_entry;
}

int Phonebook::saveToFile(const char filename[])
{
  FILE* file;
  int i, n;
 
  file = fopen(filename, "w");
  if (file == NULL)
    return -1;
  n = N_entry;
  semaphore.lock();
   for (i=0; i<n; i++)
	 {
	  fprintf(file, "%s,%s\r\n", phonebook[i].name,
	  phonebook[i].phone);
	 }
  semaphore.unlock();
  fclose(file);
  return n;
}

