
#include <atomic>
#include <mutex>

using namespace std;


struct ENTRY
{
 char name[32];
 char phone[16];
};


class Phonebook
{
 private:
    
 atomic<unsigned int> N_entry;
 unsigned int size;
 ENTRY *phonebook;
 mutex semaphore;
 
 public:
 
 // costruttore
 Phonebook(unsigned int size);
 
 // distruttore
 ~Phonebook(void);
 
 // ricerca di un nominativo o di un numero nella rubrica
 // fornisce il corrispondente numero o nominativo
 // restituisce FALSE in caso di ricerca fallita, TRUE altrimenti
 bool find(char in[], char *out);
 
 // aggiornamento del nominativo o numero di una voce della rubrica
 // aggiunge una voce alla rubrica se non esistono nominativo/numero
 // restituisce FALSE in caso di aggiornamento, TRUE in caso di aggiunta
 bool update(char name[], char phone[]);
 
 // carica le voci della rubrica dal file specificato
 // restituisce -1 in caso di errore, il numero di voci altrimenti
 int loadFromFile(const char filename[]);
 
 // salva le voci della rubrica nel file specificato
 // restituisce -1 in caso di errore, il numero di voci altrimenti
 int saveToFile(const char filename[]);
};
