
#include <iostream>
#include <thread>
#include <cstdlib>
#include <cstring>

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <unistd.h>

#include "Phonebook.h"

#define PHONEBOOK_SIZE  1000
#define TCP_PORT        23365


using namespace std;

Phonebook *phonebook;


// funzione di gestione della comunicazione con il client
void client_service(int socket_id)
{
 char *request, *name, *phone, *name_or_phone;
 unsigned char buffer[64];
 char command[64], answer[64];
 unsigned int index;
 int error;
 int i, n;
 char *p;
 
 index = 0;
 while (1)
	  {
       if ((n = recv(socket_id, (void *)buffer, sizeof(buffer), 0))<= 0)
	     {
	      // chiusura della connessione da parte del client
          cout << "Chiusura connessione." << endl;
          break;
         }
       else
		   {
            // ricezione caratteri
            for (i=0; i<n; i++)
               if (buffer[i] == '\r' || buffer[i] == '\n' || buffer[i] == '\0')
                 {
                 // ricezione completata
                 command[index] = '\0';
                 if (strlen(command) > 0)
                   {
                    error = 1;
                    request = strtok_r(command, ",\r\n\0", &p);
                    if (request != NULL)
                      {
                       if (strcmp(request, "GET") == 0)
                         {
                          // commando GET
                          name_or_phone = strtok_r(NULL, ",\r\n\0", &p);
                          if (name_or_phone != NULL)
                            {
                             if (phonebook->find(name_or_phone, answer))
                               {
                                // invio risposta al client
                                strcat(answer, "\r\n");
                                send(socket_id, answer, strlen(answer), 0);
                                error = 0;
                               }
                            }
                         }
                       if (strcmp(request, "SET") == 0)
                         {
                          // commando SET
                          name = strtok_r(NULL, ",\r\n\0", &p);
                          if (name != NULL)
                            {
                             phone = strtok_r(NULL, ",\r\n\0", &p);
                             if (phone != NULL)
                               {
                                if (strlen(name)>0 && strlen(phone)>0)
                                  {
                                   if (phonebook->update(name, phone))
                                     {
                                      // invio risposta al client
                                      send(socket_id, "OK\r\n", 4, 0);
                                      // salvataggio su file
                                      phonebook->saveToFile("rubrica.csv");
                                      error = 0;
                                     }
                                  }
                               }
                            }
                         }
                      }
                   }
                 if (error) // invio messaggio di errore al client
                   send(socket_id, "ERROR\r\n", 7, 0);
                 index = 0;
                 break;
                }
              else
                  {
                   // copia del carattere nel comando
                   if (index >= sizeof(command))
                     index = 0;
                   command[index] = buffer[i];
                   index++;
                  }
          }
      }
 close(socket_id);
}




int main(int argc, char* argv[])
{
 int request_socket_id; // socket per richieste di connessione
 int communication_socket_id; // socket di comunicazione con client
 struct sockaddr_in server_add; // struttura per indirizzo server
 struct sockaddr_in client_add; // struttura per indirizzo client
 unsigned int client_add_size;

 phonebook = new Phonebook(PHONEBOOK_SIZE);
 // caricamento rubrica da file
 if (phonebook->loadFromFile("rubrica.csv") <= 0)
   {
	cout << "Errore caricamento file!" << endl;
	return 0;
   }
 // apertura del socket
 if ((request_socket_id = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
   {
	cout << "Errore apertura socket!" << endl;
	return 0;
	}
 // costruzione della struttura per l’indirizzo del server
 memset(&server_add, 0, sizeof(server_add));
 server_add.sin_family = AF_INET;
 server_add.sin_addr.s_addr = 0;
 server_add.sin_port = htons(TCP_PORT);
 // associazione del numero di porta al socket
 if (bind( request_socket_id, (struct sockaddr *)&server_add, sizeof(server_add)) < 0)
   {
	cout << "Errore associazione socket!" << endl;
	close(request_socket_id);
	return 0;
   }
 // impostazione del socket per ricevere le richieste di connessione
 if (listen(request_socket_id, 1) < 0)
   {
	cout << "Errore impostazione socket!" << endl;
	close(request_socket_id);
	return 0;
   }
 cout << "Servizio attivo." << endl;
 while (1)
	  {
	   client_add_size = sizeof(struct sockaddr);
	   communication_socket_id = accept(request_socket_id, (struct sockaddr*)&client_add, (socklen_t*)&client_add_size);
       if (communication_socket_id >= 0)
		 {
		  cout << "Ricevuta richiesta di connessione." << endl;
		  // creazione thread di comunicazione con il client
          thread* client_thread = new thread(client_service, communication_socket_id);
          client_thread->detach();
          delete client_thread;
         }
	  }
 close(request_socket_id);
 return 0;
}
